std::ranges::view_interface< _Derived > Class Template Reference

`#include <ranges_util.h>`

Inheritance diagram for std::ranges::view_interface< _Derived >:
[legend]

## Public Member Functions

constexpr decltype(auto) | back ()
constexpr decltype(auto) | back () const
constexpr auto | data () const noexcept(noexcept(ranges::begin(_M_derived())))
constexpr auto | data () noexcept(noexcept(ranges::begin(_M_derived())))
constexpr bool | empty () const noexcept(noexcept(_S_empty(_M_derived())))
constexpr bool | empty () const noexcept(noexcept(ranges::size(_M_derived())==0))
constexpr bool | empty () noexcept(noexcept(_S_empty(_M_derived())))
constexpr bool | empty () noexcept(noexcept(ranges::size(_M_derived())==0))
constexpr decltype(auto) | front ()
constexpr decltype(auto) | front () const
constexpr | operator bool () const noexcept(noexcept(ranges::empty(_M_derived())))
constexpr | operator bool () noexcept(noexcept(ranges::empty(_M_derived())))
template<random_access_range _Range = _Derived>
constexpr decltype(auto) | operator[] (range_difference_t< _Range > __n)
template<random_access_range _Range = const _Derived>
constexpr decltype(auto) | operator[] (range_difference_t< _Range > __n) const
constexpr auto | size () const noexcept(noexcept(_S_size(_M_derived())))
constexpr auto | size () noexcept(noexcept(_S_size(_M_derived())))

## Detailed Description

template<typename _Derived>
requires is_class_v<_Derived> && same_as<_Derived, remove_cv_t<_Derived>>
class std::ranges::view_interface< _Derived >

The ranges::view_interface class template.

Definition at line 63 of file ranges_util.h.

## Member Function Documentation

## back() [1/2]

template<typename _Derived >

constexpr decltype(auto) std::ranges::view_interface< _Derived >::back | ( |  | ) |

inline constexpr

Definition at line 169 of file ranges_util.h.

## back() [2/2]

template<typename _Derived >

constexpr decltype(auto) std::ranges::view_interface< _Derived >::back | ( |  | ) | const

inline constexpr

Definition at line 177 of file ranges_util.h.

## data() [1/2]

template<typename _Derived >

constexpr auto std::ranges::view_interface< _Derived >::data | ( |  | ) | const

inline constexpr noexcept

Definition at line 136 of file ranges_util.h.

## data() [2/2]

template<typename _Derived >

constexpr auto std::ranges::view_interface< _Derived >::data | ( |  | ) |

inline constexpr noexcept

Definition at line 131 of file ranges_util.h.

## empty() [1/4]

template<typename _Derived >

constexpr bool std::ranges::view_interface< _Derived >::empty | ( |  | ) | const

inline constexpr noexcept

Definition at line 109 of file ranges_util.h.

## empty() [2/4]

template<typename _Derived >

constexpr bool std::ranges::view_interface< _Derived >::empty | ( |  | ) | const

inline constexpr noexcept

Definition at line 115 of file ranges_util.h.

## empty() [3/4]

template<typename _Derived >

constexpr bool std::ranges::view_interface< _Derived >::empty | ( |  | ) |

inline constexpr noexcept

Definition at line 97 of file ranges_util.h.

## empty() [4/4]

template<typename _Derived >

constexpr bool std::ranges::view_interface< _Derived >::empty | ( |  | ) |

inline constexpr noexcept

Definition at line 103 of file ranges_util.h.

## front() [1/2]

template<typename _Derived >

constexpr decltype(auto) std::ranges::view_interface< _Derived >::front | ( |  | ) |

inline constexpr

Definition at line 155 of file ranges_util.h.

## front() [2/2]

template<typename _Derived >

constexpr decltype(auto) std::ranges::view_interface< _Derived >::front | ( |  | ) | const

inline constexpr

Definition at line 162 of file ranges_util.h.

## operator bool() [1/2]

template<typename _Derived >

constexpr std::ranges::view_interface< _Derived >::operator bool | ( |  | ) | const

inline explicit constexpr noexcept

Definition at line 126 of file ranges_util.h.

## operator bool() [2/2]

template<typename _Derived >

constexpr std::ranges::view_interface< _Derived >::operator bool | ( |  | ) |

inline explicit constexpr noexcept

Definition at line 121 of file ranges_util.h.

## operator[]() [1/2]

template<typename _Derived >
template<random_access_range _Range = _Derived>

constexpr decltype(auto) std::ranges::view_interface< _Derived >::operator[] | ( | range_difference_t< _Range > | __n | ) |

inline constexpr

Definition at line 187 of file ranges_util.h.

## operator[]() [2/2]

template<typename _Derived >
template<random_access_range _Range = const _Derived>

constexpr decltype(auto) std::ranges::view_interface< _Derived >::operator[] | ( | range_difference_t< _Range > | __n | ) | const

inline constexpr

Definition at line 192 of file ranges_util.h.

## size() [1/2]

template<typename _Derived >

constexpr auto std::ranges::view_interface< _Derived >::size | ( |  | ) | const

inline constexpr noexcept

Definition at line 148 of file ranges_util.h.

## size() [2/2]

template<typename _Derived >

constexpr auto std::ranges::view_interface< _Derived >::size | ( |  | ) |

inline constexpr noexcept

Definition at line 142 of file ranges_util.h.

The documentation for this class was generated from the following file:

- ranges_util.h